#!/usr/bin/env ruby
require "rubygems"
require "ip"
require "ipaddr"

def usage
	puts "get_range 1.0 Robin Wood (robin@digininja.org) (www.digininja.org)\n\n"

	puts "Usage: get_range IP_ADDRESS NETMASK"
	puts "        --help, -h: show help"
	puts
	puts "Example:"
	puts "  get_range 192.168.2.98 255.255.255.0"
	puts
end

if ARGV[0] == "-h" || ARGV[0] == "--help"
	usage
	exit
end

if ARGV.length != 2
	usage
	exit
end

if /([0-9.]*)/.match ARGV[0]
	ip_address = $1
	if /([0-9.]*)/.match ARGV[1]
		mask = $1
		cidr = IPAddr.new(mask).to_i.to_s(2).count("1")

		ip = IP::CIDR.new(ip_address + "/" + cidr.to_s)
		network = ip.range[0]
		top = ip.range[1]
		bottom = ip.range[ip.range.count - 2]
		broadcast = ip.range[ip.range.count - 1]

		puts "IP address is " + ip_address
		puts "Mask of " + mask + " = /" + cidr.to_s
		puts

		puts "Network = " + network.ip_address
		puts "First address = " + top.ip_address
		puts "Last address = " + bottom.ip_address
		puts "Broadcast = " + broadcast.ip_address

		# This loop steps through each host and fires off a single quiet ping to each address

		range = ip.range.slice(2..ip.range.count - 2)
			range.each { |x|
			system "ping -q -W 1 -c 1 " + x.ip_address + " 2>&1 > /dev/null & "
		}

		exit
	end
end

usage
